#include "bibli.h"

//ne pas oublier : %hhu pour afficher/scanner des uint8_t

/*

AFFICHAGE

*/
void display_img(img * im){//noyer
  int w = im->width, h = im->height, m = im->max;
  printf("%s\n %4d %4d\n %4hhu\n",im->magic,w,h,m);
   for (int i=0;i<h;i++)
    for (int j=0;j<w;j++){
      printf("%4hhu",im->colors[i*w+j]);//à laisser
      if (j==w-1 || j == MAXCOL) printf("\n");
    }//for j
}


//pour le prof
void display_img_py(img * im, FILE * flot){
  int w = im->width, h = im->height, m = im->max;
  fprintf(flot,"[");
  for (int i=0;i<h;i++){
    fprintf(flot,"[");
    for (int j=0;j<w;j++){
      fprintf(flot,"%4u",im->colors[i*w+j]);
      if (j!=w-1) fprintf(flot,",");
      if (j==MAXCOL) fprintf(flot,"\\\n");
    }//for j
    fprintf(flot,"]");
    if (i!=h-1) fprintf(flot,",\\\n");	 
  }//for i
  fprintf(flot,"],\\\n");
  fprintf(flot,"[[\"%s\"]], [[%4d]], [[%4d]], [[%4hhu]]",im->magic,w,h,m);
  //freopen("/dev/tty", "w", stdout);
}



/*

DM3

ELEVE

*/

//création d'une image noire de taille w*h, P2 si gray==true, P1 sinon
// si P2 on met le max, sinon
img* uni(int w, int h, bool gray,COLORS m){
  img * im = mymalloc(sizeof(img));
  char *s = mymalloc(3 * sizeof(char));
  s[2]='\0';s[0]='P';
  if (gray)
    s[1]='2';
  else
    s[1]='1';
  COLORS * pxs = mycalloc(w*h,sizeof(COLORS));//blanc si P1, noir si P2
  im->magic=s;
  im->width=w;im->height=h;im->max=m;
  im->colors=pxs;
  return im;
}

img * fromfile(char * nom){  
  FILE * flot = fopen(nom,"r");
  char s [3];
  fscanf(flot,"%s",s);
  int h,w;
  fscanf(flot,"%d",&w);
  fscanf(flot,"%d",&h);
  COLORS m = 1; 
  if (s[1]=='2'){//P2
    fscanf(flot,"%hhu",&m);
  }
  //printf("FROMFILE %s %d,%d,%hhu\n",s,w,h,m);
  bool gray = (s[1]=='2');
  img * im = uni(w,h,gray,m);//image noire w * h en P2 ou P1 avec max = m
  for (int i=0;i<h;i++){
    for (int j=0;j<w;j++){
      COLORS c;
      fscanf(flot,"%hhu",&c);
      im->colors[i*w+j]=c;
    }//for j
  }//for i
  fclose(flot);
  return im;
}

void tofile(char * dest,img *im){
  FILE * flot=fopen(dest,"w");
  fprintf(flot,"%s\n",im->magic);
  int n=im->width,m=im->height,maxi=im->max;
  fprintf(flot,"%d %d\n",n,m);
  if (im->magic[1]=='2'){//P2
    fprintf(flot,"%d\n",maxi);//cette ligne n'apparaît pas dans un fichier P1
  }
  for (int i=0;i<n;i++){
    for (int j=0;j<m;j++){
      fprintf(flot,"%4d",im->colors[i * m + j]);
      if (j == m-1 || j == MAXCOL)
	fprintf(flot,"\n");
      else
	fprintf(flot," ");
    }//for j
  }//for i
  fclose(flot);
}


img * neg(img* im){
  int w=im->width,h=im->height,m=im->max;
  img * im2 = uni(w,h,true,m);
  for (int i=0;i<3;i++) im2->magic[i]=im->magic[i];
  for (int i=0;i<h;i++)
    for (int j=0;j<w;j++){
      im2->colors[i*w+j]=m-im->colors[i*w+j];
    }//for j
  return im2;
}


/*
renvoie une image au format P1 à partir d'une image au format  P2
blanc : seuil à partir duquel on considère qu'un pixel est blanc
*/
img * seuil (img * im, COLORS blanc){
  int w = im->width,h=im->height;
  img * im2 = uni(w,h,false,1);//image blanche par défaut
  for (int i=0;i<h;i++)
    for (int j=0;j<w;j++){
      COLORS v= (im->colors[i*w+j]>=blanc)? 0:1; 
      im2->colors[i*w+j]=v;
    }//for j
  return im2;
}

//inverse l'ordre des lignes
img * symh(img *im){
  int w=im->width,h=im->height,m=im->max;
  img * im2 = uni(w,h,true,m);
  for (int i=0;i<3;i++) im2->magic[i]=im->magic[i];
  for (int i=0;i<h;i++)
    for (int j=0;j<w;j++){
      im2->colors[i*w+j]=im->colors[(h-i-1)*w+j];
    }//for j
  return im2;
}


//inverse l'ordre des colonnes
img * symv(img *im){
  int w=im->width,h=im->height,m=im->max;
  img * im2 = uni(w,h,true,m);
  for (int i=0;i<3;i++) im2->magic[i]=im->magic[i];
  for (int i=0;i<h;i++)
    for (int j=0;j<w;j++){
      im2->colors[i*w+j]=im->colors[i*w+(w-1-j)];
    }//for j
  return im2;
}

void free_img(img* im){
  myfree(im->colors);
  myfree(im->magic);
  myfree(im);
}
